#include <stdio.h>

  /* Primjer za skraceno racunanje logickih izraza.
     Operatori ||, && u oba poretka, potpune tablice vrijednosti. */

int main(void)
{
    int a, b, c, x, y, a1, b1, c1;

      /* Primjer 1:
           Prvi operator je ||, a drugi je && (viseg prioriteta):
              x = a++ || b++ && c++;     isto je i sa zagradama
              x = a++ || ( b++ && c++ );
           Zatim okrenemo izraz po "komutativnosti" operatora "||":
              y = b++ && c++ || a++;
      */

    printf("\n");
    printf("  x = a++ || b++ && c++;  y = b++ && c++ || a++;\n");
    printf("\n");
    printf("  a  b  c   x   a  b  c   y   a  b  c\n");
    printf(" ------------------------------------\n");

    for (a1 = 0; a1 <= 1; ++a1)
        for (b1 = 0; b1 <= 1; ++b1)
            for (c1 = 0; c1 <= 1; ++c1) {

                a = a1; b = b1; c = c1;
                printf("  %d  %d  %d", a, b, c);
                x = a++ || b++ && c++;
                printf("   %d   %d  %d  %d", x, a, b, c);

                a = a1; b = b1; c = c1;
                y = b++ && c++ || a++;
                printf("   %d   %d  %d  %d\n", y, a, b, c);

            }

    printf("\n");

      /* Primjer 2:
           Prvi operator je && (viseg prioriteta), a drugi je ||:
              x = a++ && b++ || c++;
           Zatim okrenemo izraz po "komutativnosti" operatora &&:
              y = b++ && a++ || c++;
      */

    printf("\n");
    printf("  x = a++ && b++ || c++;  y = b++ && a++ || c++;\n");
    printf("\n");
    printf("  a  b  c   x   a  b  c   y   a  b  c\n");
    printf(" ------------------------------------\n");

    for (a1 = 0; a1 <= 1; ++a1)
        for (b1 = 0; b1 <= 1; ++b1)
            for (c1 = 0; c1 <= 1; ++c1) {

                a = a1; b = b1; c = c1;
                printf("  %d  %d  %d", a, b, c);
                x = a++ && b++ || c++;
                printf("   %d   %d  %d  %d", x, a, b, c);

                a = a1; b = b1; c = c1;
                y = b++ && a++ || c++;
                printf("   %d   %d  %d  %d\n", y, a, b, c);

            }

    return 0;
}
