#include <stdio.h>

  /* Broj znamenki broja n u bazi b.
     Potencira bazu, dok kvocijent od n i te potencije
     ne postane strogo manji od baze. Ne valja ako stavim
     da to bude manje od 1, jer opet pot ide preko n.
     Ovo nije destruktivno, n se ne mijenja.
     Posebno testira n = 0 i tad postavlja broj_znam = 0.
  */

int main(void)
{
    unsigned int b = 10, n, broj_znam, pot;

    printf(" Upisi nenegativni broj n: ");
    scanf("%u", &n);

    if (n > 0) {
        broj_znam = 1;    /* Nije vise 0. */
        pot = 1;
        while (n / pot >= b) {
            ++broj_znam;
            pot *= b;
        }
    }
    else
        broj_znam = 0;    /* Dogovor za n = 0. */

    printf("\n Broj %u ima %u znamenki u bazi %u\n",
           n, broj_znam, b);

    return 0;
}
