#include <stdio.h>

  /* Provjera je li prirodni broj palindrom.
     Stvara broj s obratnim poretkom znamenki.
     To NE mora raditi korektno, ako obratni broj NIJE prikaziv! */
  /* Kontraprimjer za ovaj algoritam:
     Broj n NIJE palindrom u bazi b, a algoritam ispisuje da JE. */

int main(void)
{
    unsigned int m = 8u * sizeof(unsigned);
    unsigned int b = ( 1u << (m - 2) ) + 1;
    unsigned int n = b + 5;

    unsigned int m1, m2, palindrom;

    printf(" Baza = %u, Broj = %u\n", b, n);

    m1 = n;
    m2 = 0;
    while (n > 0) {
        m2 = m2 * b + n % b;
        n /= b;
    }
    palindrom = m1 == m2 ? 1 : 0;

    if (palindrom)
        printf(" Broj JE palindrom.\n");
    else
        printf(" Broj NIJE palindrom.\n");

    return 0;
}
