  /* Vjezbe: Zadatak 10.1.10. (str. 114), modificiran

     Napisite funkciju koja dobiva prirodni broj n i vraca
     broj razlicitih prostih faktora tog broja, s tim da svaki faktor
     broji samo jednom.
     Napomena: sve radimo u tipu int (ignoriramo brojeve <= 0).
  */

  /* Druga varijanta funkcije --- dijeljenje broja:
       - nalazi redom faktore, pocev od 2, i dijeli ih iz n,
         sve dok n ne postane 1.

     Glavni program testira funkciju za ucitani broj n.
  */

#include <stdio.h>
#include <math.h>


    /* Funckija za broj razlicitih prostih djelitelja broja. */

int broj_prost_fakt_2(int n)
{
        /* Testira redom faktore od n, pocev od 2, i dijeli ih iz n. */

    int br_pfakt = 0;
    int d;

        /* Brojevi <= 1 nemaju proste faktore (ignoriramo <= 0). */
    if (n <= 1) return 0;

        /* Petlja po svim mogucim faktorima od n, pocev od 2.
           Ako je d faktor, podijeli n s tim faktorom dok ide.
           Takav faktor je sigurno prost, */

    for (d = 2; n > 1; ++d)
        if (n % d == 0) {
                /* Obrada prostog faktora d, samo jednom. */
            ++br_pfakt;

                /* Dijeli n s d, sve dok je djeljiv. */
            do
                n /= d;
            while (n % d == 0);
        }

    return br_pfakt;
}


int main(void)
{
    int n;

    printf(" Upisi broj n: ");
    scanf("%d", &n);

    printf("\n Broj razlicitih prostih faktora od %d je %d\n",
           n, broj_prost_fakt_2(n));

    return 0;
}
