#include <stdio.h>

  /* Ispis znamenki broja n u bazi b.
     Ispisuje znamenku 0 kad je ulazni n = 0.
     Rekurzivna funkcija.
     Glavni program ucitava n i bazu b.
  */

  /* Uocite: puno je lakse modificirati glavni program da pita je li n == 0,
     i onda napise znamenku 0.
       Ako bas hocemo da funkcija to radi, onda funkcija MORA znati je li
     to prvi poziv (izvana), ili je dublje u rekurziji (tj. ona je pozvala
     samu sebe). Zato funkcija mora dobiti jos jedan argument, nazovimo
     ga PRVI. Za poziv izvana, taj argument je 1, a unutar funkcije je 0.
  */

void ispis_u_bazi(unsigned int n, unsigned int b,
                  int prvi)
{
    if (n > 0) {
        ispis_u_bazi(n / b, b, 0);
        printf("%u", n % b);
    }
    else    /* Mora biti n = 0. */
        if (prvi) printf("0");    /* Moze i printf("%u", n); */

    return;
}

int main(void)
{
    unsigned int b, n;

    printf(" Upisi nenegativni broj n i bazu b: ");
    scanf("%u%u", &n, &b);

    printf("\n Prikaz broja %u u bazi %u: ", n, b);

    ispis_u_bazi(n, b, 1);

    printf("\n");

    return 0;
}
