#include <stdio.h>

  /* Binarno pretrazivanje - Zadatak 2.
     Ima samo jednu usporedbu u petlji i jos jednu na kraju.

     Ovdje se "cuva" DESNI rub intervala, tj. srednji element
     ulazi u LIJEVI dio (kao DESNI rub), a desni dio je bez srednjeg.
     Zavrsna usporedba je s elementom x[d] (moze i x[l]).

     Ova varijanta radi dobro! */

int binary_search_1_d(int x[], int n, int elt)
{
    int l = 0, d = n - 1, i;

    while (l < d) {          /* Strogo manje! */
        i = (l + d) / 2;
        if (elt <= x[i])
            d = i;           /* Ne: i - 1.  */
        else                 /* elt > x[i] */
            l = i + 1;
    }

    return (elt == x[d]);    /* Moze: elt == x[l] */
}

int main(void)
{
    int n, elt, nasao;
    int x[] = {12, 18, 42, 44, 55, 67, 94};

    n = 7;

    printf("\n Upisi broj koji trazis u polju\n");
    scanf("%d", &elt);

    nasao = binary_search_1_d(x, n, elt);

    if (nasao)
        printf(" U polju x nasao element %d\n", elt);
    else
        printf(" U polju x nema elementa %d\n", elt);

    return 0;
}
