#include <stdio.h>

  /* Binomni koeficijenti i Pascalov trokut.
     Funkcija binom s vjezbi - prvo pomnozi, onda dijeli.
     To NIJE dobro, jer umnozak brzo naraste (moze biti neprikaziv). */

    /* Funkcija binom(n, k) racuna binomni
       koeficijent n povrh k. */

int binom(int n, int k)
{
    int bin_coef, j;

        /* Provjera granica i signal greske. */
    if (n < 0 || k < 0 || k > n) return 0;

        /* Smanji donji argument. */
    if (k > n - k) k = n - k;

    if (k == 0) return 1;

    bin_coef = 1;
    for (j = n; j > n - k; --j)
        bin_coef = bin_coef * j;
    for (j = 2; j <= k; ++j)
        bin_coef = bin_coef / j;

    return bin_coef;
}


    /* Glavni program ispisuje prvih 20 redova
       Pascalovog trokuta. */

int main(void)
{
    int n, k;

    for (n = 0; n <= 20; ++n) {
        for (k = 0; k <= n; ++k)
            printf("%d ", binom(n, k));
        printf("\n");
    }

    return 0;
}
