#include <stdio.h>

  /* Broj znamenki broja n u bazi b.
     Realizacija FUNKCIJOM.
       Unistava n dijeljenjem.
       Kod funkcije, to nije problem, jer je n lokalna varijabla.
  */

unsigned int broj_znamenki(unsigned int n,
                           unsigned int b)
{
    unsigned int broj_znam = 0;

    while (n > 0) {
        ++broj_znam;
        n /= b;
    }
    return broj_znam;
}

int main(void)
{
    unsigned int b = 10, n;

    printf(" Upisi nenegativni broj n: ");
    scanf("%u", &n);

    printf("\n Broj %u ima %u znamenki u bazi %u\n",
           n, broj_znamenki(n, b), b);

    return 0;
}
