#include <stdio.h>

/****************************************************************************/

  /* Selection sort algoritam (izbor ekstrema).
     Varijanta s 13. predavanja iz Prog1 (min_2).
     Najmanji na pocetak, pamti samo indeks najmanjeg.
  */

/****************************************************************************/

  /* Uzlazno sortiranje izborom ekstrema.
     Dovodimo najmanji element na pocetak.
     Pamti samo indeks najmanjeg. */

void selection_sort(int x[], int n)
{
    int i, j, ind_min, temp;

    for (i = 0; i < n - 1; ++i) {
        ind_min = i;
        for (j = i + 1; j < n; ++j)
            if (x[j] < x[ind_min])
                ind_min = j;
        if (i != ind_min) {
            temp = x[i];
            x[i] = x[ind_min];
            x[ind_min] = temp;
        }
    }
      
    return;
}

/****************************************************************************/

int main(void)
{
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;
    selection_sort(x, n);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    return 0;
}
